//
//  AppDelegate.m
//  UltraSDKDemo
//
//  Created by 魏太山 on 2021/7/27.
//

#import "AppDelegate.h"
#import <UltraSDK/UltraSDK.h>
// iOS10 注册 APNs 所需头文件
#ifdef NSFoundationVersionNumber_iOS_9_x_Max
#import <UserNotifications/UserNotifications.h>
#endif
@interface AppDelegate ()<UltraPUSHRegisterDelegate>

@end

@implementation AppDelegate


- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    // Override point for customization after application launch.
    UltraProject *uProject = [[UltraProject alloc] init];
    uProject.ultraProductId = @"11008";
    uProject.ultraProductKey = @"uzx6ntl00spbv9jhdiu5";
    [[UltraPlatform sharedInstance] initWithProject:uProject];
    
    //Required
    UltraPUSHRegisterEntity * entity = [[UltraPUSHRegisterEntity alloc] init];
    entity.types = UltraPAuthorizationOptionAlert|UltraPAuthorizationOptionBadge|UltraPAuthorizationOptionSound;
    [UltraPUSHService registerForRemoteNotificationConfig:entity delegate:self];
    
    return YES;
}

- (BOOL)application:(UIApplication *)application openURL:(NSURL *)url sourceApplication:(NSString *)sourceApplication annotation:(id)annotation{
    [[UltraPlatform sharedInstance] ultra_application:application handleOpenURL:url] ;
    return YES;
}

- (BOOL)application:(UIApplication *)application handleOpenURL:(NSURL *)url{
    [[UltraPlatform sharedInstance] ultra_application:application handleOpenURL:url] ;
    return YES;
}

- (BOOL)application:(UIApplication *)app openURL:(NSURL *)url options:(NSDictionary<UIApplicationOpenURLOptionsKey,id> *)options{
    [[UltraPlatform sharedInstance] ultra_application:app handleOpenURL:url] ;
    return YES;
}

// 3.4.6后新增
- (BOOL)application:(UIApplication *)application continueUserActivity:(NSUserActivity *)userActivity restorationHandler:(void(^)(NSArray<id<UIUserActivityRestoring>> * __nullable restorableObjects))restorationHandler{
    [[UltraPlatform sharedInstance] handleOpenUniversalLink:userActivity];
    return YES ;
}


#pragma 推送相关
- (void)application:(UIApplication *)application
didRegisterForRemoteNotificationsWithDeviceToken:(NSData *)deviceToken {
  /// Required - 注册 DeviceToken
  [UltraPUSHService registerDeviceToken:deviceToken];
}

- (void)application:(UIApplication *)application didFailToRegisterForRemoteNotificationsWithError:(NSError *)error {
  //Optional
  NSLog(@"did Fail To Register For Remote Notifications With Error: %@", error);
}

- (void)applicationDidEnterBackground:(UIApplication *)application {

  [[UIApplication sharedApplication] setApplicationIconBadgeNumber:0];
}

- (void)applicationWillEnterForeground:(UIApplication *)application {

  [application setApplicationIconBadgeNumber:0];
  [application cancelAllLocalNotifications];

}

- (void)application:(UIApplication *)application didReceiveRemoteNotification:(NSDictionary *)userInfo fetchCompletionHandler:(void (^)(UIBackgroundFetchResult))completionHandler {

    NSLog(@"ios7 pushUserInfo = %@",userInfo);
  // Required, iOS 7 Support
    [UltraPUSHService handleRemoteNotification:userInfo];
    [self pushVCWithInfo:userInfo];
    completionHandler(UIBackgroundFetchResultNewData);
}

- (void)application:(UIApplication *)application didReceiveRemoteNotification:(NSDictionary *)userInfo {

    NSLog(@"ios6 pushUserInfo = %@",userInfo);
  // Required, For systems with less than or equal to iOS 6
    [UltraPUSHService handleRemoteNotification:userInfo];
    [self pushVCWithInfo:userInfo];
}

- (void)ultraPushNotificationAuthorization:(UltraPAuthorizationStatus)status withInfo:(NSDictionary *)info {
    NSLog(@"receive notification authorization status:%lu, info:%@", status, info);

}

//ios 12以后
-(void)ultraPushNotificationCenter:(UNUserNotificationCenter *)center openSettingsForNotification:(UNNotification *)notification{
    
    NSDictionary * userInfo = notification.request.content.userInfo;
    NSLog(@"ios12 pushUserInfo = %@",userInfo);
    if (notification && [notification.request.trigger isKindOfClass:[UNPushNotificationTrigger class]]) {
        //从通知界面直接进入应用
        NSLog(@"从通知界面直接进入应用");
    }else{
        //从通知设置界面进入应用
        NSLog(@"从通知设置界面进入应用");
    }
}

//iOS10 点击通知
- (void)ultraPushNotificationCenter:(UNUserNotificationCenter *)center didReceiveNotificationResponse:(UNNotificationResponse *)response withCompletionHandler:(void (^)(void))completionHandler  API_AVAILABLE(ios(10.0)){
    NSDictionary * userInfo = response.notification.request.content.userInfo;
    UNNotificationRequest *request = response.notification.request; // 收到推送的请求
    UNNotificationContent *content = request.content; // 收到推送的消息内容
    
    NSNumber *badge = content.badge;  // 推送消息的角标
    NSString *body = content.body;    // 推送消息体
    UNNotificationSound *sound = content.sound;  // 推送消息的声音
    NSString *subtitle = content.subtitle;  // 推送消息的副标题
    NSString *title = content.title;  // 推送消息的标题
    
    if([response.notification.request.trigger isKindOfClass:[UNPushNotificationTrigger class]]) {
        [UltraPUSHService handleRemoteNotification:userInfo];
        [self pushVCWithInfo:userInfo];
        NSLog(@"iOS10 收到远程通知:%@", userInfo);
        
    }
    else {
      // 判断为本地通知
      NSLog(@"iOS10 收到本地通知:{\nbody:%@，\ntitle:%@,\nsubtitle:%@,\nbadge：%@，\nsound：%@，\nuserInfo：%@\n}",body,title,subtitle,badge,sound,userInfo);
    }
    
    completionHandler();  // 系统要求执行这个方法
}

//iOS10 前台收到远程通知
- (void)ultraPushNotificationCenter:(UNUserNotificationCenter *)center willPresentNotification:(UNNotification *)notification withCompletionHandler:(void (^)(NSUInteger))completionHandler  API_AVAILABLE(ios(10.0)){
    
    NSDictionary * userInfo = notification.request.content.userInfo;
    
    UNNotificationRequest *request = notification.request; // 收到推送的请求
    UNNotificationContent *content = request.content; // 收到推送的消息内容
    
    NSNumber *badge = content.badge;  // 推送消息的角标
    NSString *body = content.body;    // 推送消息体
    UNNotificationSound *sound = content.sound;  // 推送消息的声音
    NSString *subtitle = content.subtitle;  // 推送消息的副标题
    NSString *title = content.title;  // 推送消息的标题
    
    if([notification.request.trigger isKindOfClass:[UNPushNotificationTrigger class]]) {
      [UltraPUSHService handleRemoteNotification:userInfo];
      NSLog(@"iOS10 前台收到远程通知:%@", userInfo);

    }
    else {
      // 判断为本地通知
      NSLog(@"iOS10 前台收到本地通知:{\nbody:%@，\ntitle:%@,\nsubtitle:%@,\nbadge：%@，\nsound：%@，\nuserInfo：%@\n}",body,title,subtitle,badge,sound,userInfo);
    }

    //如果要应用在前台也弹出通知栏，则选择下面的选项
    completionHandler(UNNotificationPresentationOptionBadge|UNNotificationPresentationOptionSound|UNNotificationPresentationOptionAlert); // 需要执行这个方法，选择是否提醒用户，有Badge、Sound、Alert三种类型可以设置
    
    //设置为None则前台不提醒
//    completionHandler(UNNotificationPresentationOptionNone);

}

// 这里处理自己的推送逻辑
- (void)pushVCWithInfo:(NSDictionary *)remoteInfo{
  
  NSString* type = [NSString stringWithFormat:@"%@",remoteInfo[@"type"]];
    NSString* value = [NSString stringWithFormat:@"%@",remoteInfo[@"value"]];
    
    //默认类型，点击推送打开app
    if ([type isEqualToString:@"openApp"]) {
        
    //点击推送打开网址
    }else if ([type isEqualToString:@"openUrl"]){
        
        NSString* urlString = @"https://www.yingxiong.com/";
        if (value.length) {
            urlString = value;
        }
        if (@available(iOS 10.0, *)) {
              [[UIApplication sharedApplication] openURL:[NSURL URLWithString:urlString] options:@{} completionHandler:^(BOOL success) {
                  
              }];
          } else {
              [[UIApplication sharedApplication] openURL:[NSURL URLWithString:urlString]] ;
          }
    
    //点击推送套装到对应的页面
    }else if ([type isEqualToString:@"openPage"]){
        
        if ([value isEqualToString:@"page1"]) {
            
        }else if ([value isEqualToString:@"page2"]){

        }
    }
}



@end
